## cura-engine 2.5.0

=== CMakeLists.txt ===
project(CuraEngine)

cmake_minimum_required(VERSION 2.8.12)

option (ENABLE_ARCUS
    "Enable support for ARCUS" ON)

if (ENABLE_ARCUS)
    message(STATUS "Building with Arcus")
    find_package(Arcus REQUIRED)
    add_definitions(-DARCUS)
endif ()

if(NOT ${CMAKE_VERSION} VERSION_LESS 3.1)
    set(CMAKE_CXX_STANDARD 11)
else()
    set(CMAKE_CXX_FLAGS "-std=c++11")
endif()

if(APPLE AND CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -stdlib=libc++")
endif()

set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")

set(CURA_ENGINE_VERSION "master" CACHE STRING "Version name of Cura")

option(BUILD_TESTS OFF)

# Add a compiler flag to check the output for insane values if we are in debug mode.
if(CMAKE_BUILD_TYPE MATCHES DEBUG OR CMAKE_BUILD_TYPE MATCHES RelWithDebInfo)
    message(STATUS "Building debug release of CuraEngine.")
    add_definitions(-DASSERT_INSANE_OUTPUT)
    add_definitions(-DUSE_CPU_TIME)
    add_definitions(-DDEBUG)
endif()

# Add warnings
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")

if(NOT APPLE AND NOT WIN32)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -static-libstdc++")
endif()

option (ENABLE_OPENMP
    "Use OpenMP for parallel code" ON)

if (ENABLE_OPENMP)
    FIND_PACKAGE( OpenMP )
    if( OPENMP_FOUND )
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}" )
    endif()
endif()

include_directories(${CMAKE_CURRENT_BINARY_DIR} libs)

add_library(clipper STATIC libs/clipper/clipper.cpp)

set(engine_SRCS # Except main.cpp.
    src/bridge.cpp
    src/commandSocket.cpp
    src/ConicalOverhang.cpp
    src/ExtruderTrain.cpp
    src/FffGcodeWriter.cpp
    src/FffPolygonGenerator.cpp
    src/FffProcessor.cpp
    src/gcodeExport.cpp
    src/GCodePathConfig.cpp
    src/infill.cpp
    src/layerPart.cpp
    src/LayerPlan.cpp
    src/LayerPlanBuffer.cpp
    src/MergeInfillLines.cpp
    src/mesh.cpp
    src/MeshGroup.cpp
    src/multiVolumes.cpp
    src/pathOrderOptimizer.cpp
    src/Preheat.cpp
    src/PrimeTower.cpp
    src/raft.cpp
    src/skin.cpp
    src/SkirtBrim.cpp
    src/sliceDataStorage.cpp
    src/slicer.cpp
    src/support.cpp
    src/timeEstimate.cpp
    src/WallsComputation.cpp
    src/wallOverlap.cpp
    src/Weaver.cpp
    src/Wireframe2gcode.cpp

    src/infill/NoZigZagConnectorProcessor.cpp
    src/infill/ZigzagConnectorProcessorConnectedEndPieces.cpp
    src/infill/ZigzagConnectorProcessorDisconnectedEndPieces.cpp
    src/infill/ZigzagConnectorProcessorEndPieces.cpp
    src/infill/ZigzagConnectorProcessorNoEndPieces.cpp
    src/infill/SubDivCube.cpp

    src/pathPlanning/Comb.cpp
    src/pathPlanning/GCodePath.cpp
    src/pathPlanning/LinePolygonsCrossings.cpp
    src/pathPlanning/NozzleTempInsert.cpp
    src/pathPlanning/TimeMaterialEstimates.cpp

    src/progress/Progress.cpp
    src/progress/ProgressStageEstimator.cpp

    src/settings/PathConfigStorage.cpp
    src/settings/SettingConfig.cpp
    src/settings/SettingContainer.cpp
    src/settings/SettingRegistry.cpp
    src/settings/settings.cpp

    src/utils/AABB.cpp
    src/utils/AABB3D.cpp
    src/utils/Date.cpp
    src/utils/gettime.cpp
    src/utils/LinearAlg2D.cpp
    src/utils/ListPolyIt.cpp
    src/utils/logoutput.cpp
    src/utils/PolygonProximityLinker.cpp
    src/utils/polygonUtils.cpp
    src/utils/polygon.cpp
    src/utils/ProximityPointLink.cpp
)

# List of tests. For each test there must be a file tests/${NAME}.cpp and a file tests/${NAME}.h.
set(engine_TEST_INFILL
)
set(engine_TEST_UTILS
    SparseGridTest
    LinearAlg2DTest
    PolygonUtilsTest
    PolygonTest
    StringTest
)

# Generating ProtoBuf protocol
if (ENABLE_ARCUS)
protobuf_generate_cpp(engine_PB_SRCS engine_PB_HEADERS Cura.proto)
endif ()

# Compiling CuraEngine itself.
add_library(_CuraEngine ${engine_SRCS} ${engine_PB_SRCS}) #First compile all of CuraEngine as library, allowing this to be re-used for tests.
target_link_libraries(_CuraEngine clipper)
if (ENABLE_ARCUS)
    target_link_libraries(_CuraEngine Arcus)
endif ()

set_target_properties(_CuraEngine PROPERTIES COMPILE_DEFINITIONS "VERSION=\"${CURA_ENGINE_VERSION}\"")

if (UNIX)
    target_link_libraries(_CuraEngine pthread)
endif()
add_executable(CuraEngine src/main.cpp) #Then compile main.cpp as separate executable, and link the library to it.
target_link_libraries(CuraEngine _CuraEngine)

# Compiling the test environment.
if (BUILD_TESTS)
    message(STATUS "Building tests...")
    enable_testing()
    foreach (test ${engine_TEST})
        add_executable(${test} tests/main.cpp tests/${test}.cpp)
        target_link_libraries(${test} _CuraEngine cppunit)
        add_test(${test} ${test})
    endforeach()
    foreach (test ${engine_TEST_INFILL})
        add_executable(${test} tests/main.cpp tests/infill/${test}.cpp)
        target_link_libraries(${test} _CuraEngine cppunit)
        add_test(${test} ${test})
    endforeach()
    foreach (test ${engine_TEST_UTILS})
        add_executable(${test} tests/main.cpp tests/utils/${test}.cpp)
        target_link_libraries(${test} _CuraEngine cppunit)
        add_test(${test} ${test})
    endforeach()
endif()


add_custom_command(TARGET CuraEngine POST_BUILD
                   COMMAND ${CMAKE_COMMAND} -E copy_directory
                       ${CMAKE_SOURCE_DIR}/resources $<TARGET_FILE_DIR:CuraEngine>)

# Installing CuraEngine.
include(GNUInstallDirs)
install(TARGETS CuraEngine DESTINATION ${CMAKE_INSTALL_BINDIR})
include(CPackConfig.cmake)

=== debian/changelog ===
cura-engine (1:2.5.0-3) unstable; urgency=medium

  [ Gregor Riepl ]
  * Added printer definition file for autopkgtest.
  * Added missing extruder definition for autopkgtest.
  * Added missing cinttypes include to StringTest and document
    upstream PR link.

  [ Petter Reinholdtsen ]
  * Restructured debian/patches/ to number based on source and planned trajectory.

 -- Petter Reinholdtsen <pere@debian.org>  Tue, 17 Oct 2017 10:49:17 +0200

cura-engine (1:2.5.0-2) unstable; urgency=medium

  * Added 1000-64-bit-safe-stringtest.patch to fix build problem on
    some architectures.

 -- Petter Reinholdtsen <pere@debian.org>  Sat, 07 Oct 2017 18:20:53 +0000

cura-engine (1:2.5.0-1) unstable; urgency=medium

  [ Gregor Riepl ]
  * New upstream version (Closes: #744112).
  * Updated maintainer to 3dprinter list
  * Incremented epoch to work around version conflict with CuraEngine 1

  [ Petter Reinholdtsen ]
  * Added cura-engine.docs to include documentation in package.
  * Added simple autopkgtest script to test the slicing.
  * Enable build time testing and add 0010-64-bit-safe-writeInt2mm.patch.
  * Changed Standards-Version from 4.1.0 to 4.1.1.
  * Disabled use of arcus until libarcus is in unstable.

 -- Petter Reinholdtsen <pere@debian.org>  Fri, 06 Oct 2017 23:14:24 +0200

cura-engine (14.01-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Bump Standards-Version to 3.9.8, no changes needed.
  * Apply patch from Graham Inggs <ginggs@debian.org> to fix FTBFS with a
    recent toolchain.  Closes: #818140

 -- Mattia Rizzolo <mattia@debian.org>  Thu, 09 Mar 2017 13:43:30 +0100

cura-engine (14.01-2) unstable; urgency=medium

  * Add pkg-config build dependency. (Closes: #737942)
  * Add python build dependency to allow running tests.

 -- Bas Wijnen <wijnen@debian.org>  Fri, 07 Feb 2014 16:59:54 -0500

cura-engine (14.01-1) unstable; urgency=low

  * Initial Release. (Closes: #729146)
  * Make include paths nicer.
  * Use system clipper library.
  * Report correct version.

 -- Bas Wijnen <wijnen@debian.org>  Tue, 04 Feb 2014 20:14:06 -0500

=== debian/control ===
Source: cura-engine
Priority: optional
Maintainer: Debian 3-D Printing Packages <3dprinter-general@lists.alioth.debian.org>
Uploaders: Gregor Riepl <onitake@gmail.com>
Build-Depends: debhelper (>= 10), cmake (>=2.8.12),
 pkg-config (>=0.29),
 libcppunit-dev,
 protobuf-compiler (>=3.0.0), libprotobuf-dev,
 rapidjson-dev, libpolyclipping-dev,
Standards-Version: 4.1.1
Section: utils
Homepage: https://github.com/Ultimaker/CuraEngine
Vcs-Browser: https://anonscm.debian.org/cgit/3dprinter/packages/cura-engine.git/
Vcs-Git: https://anonscm.debian.org/git/3dprinter/packages/cura-engine.git

Package: cura-engine
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: command line slicer engine for 3d printing
 The CuraEngine is a C++ console application for 3D printing
 GCode generation. It has been made as a better and faster
 alternative to the old Skeinforge engine.

## cura-engine 3.0.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -30,6 +30,7 @@
 # Add a compiler flag to check the output for insane values if we are in debug mode.
 if(CMAKE_BUILD_TYPE MATCHES DEBUG OR CMAKE_BUILD_TYPE MATCHES RelWithDebInfo)
     message(STATUS "Building debug release of CuraEngine.")
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wextra")
     add_definitions(-DASSERT_INSANE_OUTPUT)
     add_definitions(-DUSE_CPU_TIME)
     add_definitions(-DDEBUG)
@@ -67,12 +68,14 @@
     src/gcodeExport.cpp
     src/GCodePathConfig.cpp
     src/infill.cpp
+    src/InsetOrderOptimizer.cpp
     src/layerPart.cpp
     src/LayerPlan.cpp
     src/LayerPlanBuffer.cpp
     src/MergeInfillLines.cpp
     src/mesh.cpp
     src/MeshGroup.cpp
+    src/Mold.cpp
     src/multiVolumes.cpp
     src/pathOrderOptimizer.cpp
     src/Preheat.cpp
@@ -80,20 +83,22 @@
     src/raft.cpp
     src/skin.cpp
     src/SkirtBrim.cpp
+    src/SupportInfillPart.cpp
     src/sliceDataStorage.cpp
     src/slicer.cpp
     src/support.cpp
     src/timeEstimate.cpp
+    src/TopSurface.cpp
     src/WallsComputation.cpp
     src/wallOverlap.cpp
     src/Weaver.cpp
     src/Wireframe2gcode.cpp
 
     src/infill/NoZigZagConnectorProcessor.cpp
-    src/infill/ZigzagConnectorProcessorConnectedEndPieces.cpp
-    src/infill/ZigzagConnectorProcessorDisconnectedEndPieces.cpp
-    src/infill/ZigzagConnectorProcessorEndPieces.cpp
-    src/infill/ZigzagConnectorProcessorNoEndPieces.cpp
+    src/infill/ZigzagConnectorProcessor.cpp
+    src/infill/SpaceFillingTreeFill.cpp
+    src/infill/SpaghettiInfill.cpp
+    src/infill/SpaghettiInfillPathGenerator.cpp
     src/infill/SubDivCube.cpp
 
     src/pathPlanning/Comb.cpp
@@ -118,17 +123,21 @@
     src/utils/LinearAlg2D.cpp
     src/utils/ListPolyIt.cpp
     src/utils/logoutput.cpp
+    src/utils/PolygonsPointIndex.cpp
     src/utils/PolygonProximityLinker.cpp
     src/utils/polygonUtils.cpp
     src/utils/polygon.cpp
     src/utils/ProximityPointLink.cpp
+    src/utils/SpaceFillingTree.cpp
 )
 
 # List of tests. For each test there must be a file tests/${NAME}.cpp and a file tests/${NAME}.h.
 set(engine_TEST_INFILL
+    SpaceFillingTreeFillTest
 )
 set(engine_TEST_UTILS
     SparseGridTest
+    IntPointTest
     LinearAlg2DTest
     PolygonUtilsTest
     PolygonTest
@@ -158,6 +167,9 @@
 # Compiling the test environment.
 if (BUILD_TESTS)
     message(STATUS "Building tests...")
+
+    find_package(cppunit)
+
     enable_testing()
     foreach (test ${engine_TEST})
         add_executable(${test} tests/main.cpp tests/${test}.cpp)

=== debian/changelog ===
cura-engine (1:3.0.3-2) unstable; urgency=medium

  * Re-enabled libArcus support, as it's available in Debian now

 -- Gregor Riepl <onitake@gmail.com>  Tue, 28 Nov 2017 23:56:18 +0100

cura-engine (1:3.0.3-1) unstable; urgency=medium

  [ Gregor Riepl ]
  * New upstream release 3.0.3.
  * Updated d/copyright.
  * Updated manpage.
  * Redirected autopkgtest script output to stdout to allow tests to succeed.

 -- Petter Reinholdtsen <pere@debian.org>  Thu, 02 Nov 2017 12:51:42 +0000

=== debian/control ===
--- 
+++ 
@@ -7,6 +7,7 @@
  libcppunit-dev,
  protobuf-compiler (>=3.0.0), libprotobuf-dev,
  rapidjson-dev, libpolyclipping-dev,
+ libarcus-dev (>=3.0.3)
 Standards-Version: 4.1.1
 Section: utils
 Homepage: https://github.com/Ultimaker/CuraEngine

## cura-engine 3.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,10 @@
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -stdlib=libc++")
 endif()
 
-set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
+if(NOT DEFINED LIB_SUFFIX)
+    set(LIB_SUFFIX "")
+endif()
+set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}")
 
 set(CURA_ENGINE_VERSION "master" CACHE STRING "Version name of Cura")
 
@@ -30,7 +33,7 @@
 # Add a compiler flag to check the output for insane values if we are in debug mode.
 if(CMAKE_BUILD_TYPE MATCHES DEBUG OR CMAKE_BUILD_TYPE MATCHES RelWithDebInfo)
     message(STATUS "Building debug release of CuraEngine.")
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wextra")
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wextra -O0 -g -fno-omit-frame-pointer")
     add_definitions(-DASSERT_INSANE_OUTPUT)
     add_definitions(-DUSE_CPU_TIME)
     add_definitions(-DDEBUG)
@@ -129,6 +132,7 @@
     src/utils/polygon.cpp
     src/utils/ProximityPointLink.cpp
     src/utils/SpaceFillingTree.cpp
+    src/utils/socket.cpp
 )
 
 # List of tests. For each test there must be a file tests/${NAME}.cpp and a file tests/${NAME}.h.

=== debian/changelog ===
cura-engine (1:3.1.0-2) unstable; urgency=medium

  * Fixed profiles for autopkgtest (Closes: #889004)

 -- Gregor Riepl <onitake@gmail.com>  Thu, 01 Feb 2018 08:36:23 +0100

cura-engine (1:3.1.0-1) unstable; urgency=medium

  * New upstream release 3.1.0
  * Fixed version being misreported as DEV

 -- Gregor Riepl <onitake@gmail.com>  Fri, 26 Jan 2018 08:34:59 +0100

=== debian/control ===
--- 
+++ 
@@ -7,8 +7,8 @@
  libcppunit-dev,
  protobuf-compiler (>=3.0.0), libprotobuf-dev,
  rapidjson-dev, libpolyclipping-dev,
- libarcus-dev (>=3.0.3)
-Standards-Version: 4.1.1
+ libarcus-dev (>=3.1.0)
+Standards-Version: 4.1.3
 Section: utils
 Homepage: https://github.com/Ultimaker/CuraEngine
 Vcs-Browser: https://anonscm.debian.org/cgit/3dprinter/packages/cura-engine.git/

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

%:
	dh $@ --buildsystem=cmake --parallel

override_dh_auto_configure:
	dh_auto_configure -- -DCURA_ENGINE_VERSION:STRING=$(DEB_VERSION_UPSTREAM) -DBUILD_TESTS=ON

## cura-engine 3.3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,10 +11,25 @@
     add_definitions(-DARCUS)
 endif ()
 
+
+option(USE_SYSTEM_LIBS "Use the system libraries if available" OFF)
+
+if(USE_SYSTEM_LIBS)
+    set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
+    find_package(RapidJSON CONFIG REQUIRED)
+    find_package(Polyclipping REQUIRED)
+endif()
+
+if(CMAKE_BUILD_TYPE MATCHES "Debug")
+    set(CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS_DEBUG_INIT})
+else()
+    set(CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS_RELEASE_INIT})
+endif()
+
 if(NOT ${CMAKE_VERSION} VERSION_LESS 3.1)
     set(CMAKE_CXX_STANDARD 11)
 else()
-    set(CMAKE_CXX_FLAGS "-std=c++11")
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
 endif()
 
 if(APPLE AND CMAKE_CXX_COMPILER_ID MATCHES "Clang")
@@ -39,8 +54,14 @@
     add_definitions(-DDEBUG)
 endif()
 
-# Add warnings
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall") # Add warnings
+
+option (ENABLE_MORE_COMPILER_OPTIMIZATION_FLAGS
+    "Enable more optimization flags" ON)
+if (ENABLE_MORE_COMPILER_OPTIMIZATION_FLAGS)
+    message (STATUS "Compile with more optimization flags")
+    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS} -Ofast -funroll-loops")
+endif ()
 
 if(NOT APPLE AND NOT WIN32)
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -static-libstdc++")
@@ -56,9 +77,12 @@
     endif()
 endif()
 
-include_directories(${CMAKE_CURRENT_BINARY_DIR} libs)
-
-add_library(clipper STATIC libs/clipper/clipper.cpp)
+if(USE_SYSTEM_LIBS)
+    include_directories(${Polyclipping_INCLUDE_DIRS} ${CMAKE_BINARY_DIR} ${RAPIDJSON_INCLUDE_DIRS})
+else()
+    include_directories(${CMAKE_CURRENT_BINARY_DIR} libs libs/clipper)
+    add_library(clipper STATIC libs/clipper/clipper.cpp)
+endif()
 
 set(engine_SRCS # Except main.cpp.
     src/bridge.cpp
@@ -92,6 +116,7 @@
     src/support.cpp
     src/timeEstimate.cpp
     src/TopSurface.cpp
+    src/TreeSupport.cpp
     src/WallsComputation.cpp
     src/wallOverlap.cpp
     src/Weaver.cpp
@@ -118,6 +143,7 @@
     src/settings/SettingContainer.cpp
     src/settings/SettingRegistry.cpp
     src/settings/settings.cpp
+    src/settings/AdaptiveLayerHeights.cpp
 
     src/utils/AABB.cpp
     src/utils/AABB3D.cpp
@@ -126,13 +152,15 @@
     src/utils/LinearAlg2D.cpp
     src/utils/ListPolyIt.cpp
     src/utils/logoutput.cpp
+    src/utils/MinimumSpanningTree.cpp
     src/utils/PolygonsPointIndex.cpp
     src/utils/PolygonProximityLinker.cpp
     src/utils/polygonUtils.cpp
     src/utils/polygon.cpp
     src/utils/ProximityPointLink.cpp
+    src/utils/SVG.cpp
+    src/utils/socket.cpp
     src/utils/SpaceFillingTree.cpp
-    src/utils/socket.cpp
 )
 
 # List of tests. For each test there must be a file tests/${NAME}.cpp and a file tests/${NAME}.h.
@@ -146,27 +174,51 @@
     PolygonUtilsTest
     PolygonTest
     StringTest
+    UnionFindTest
 )
 
 # Generating ProtoBuf protocol
 if (ENABLE_ARCUS)
-protobuf_generate_cpp(engine_PB_SRCS engine_PB_HEADERS Cura.proto)
+    protobuf_generate_cpp(engine_PB_SRCS engine_PB_HEADERS Cura.proto)
 endif ()
 
 # Compiling CuraEngine itself.
 add_library(_CuraEngine ${engine_SRCS} ${engine_PB_SRCS}) #First compile all of CuraEngine as library, allowing this to be re-used for tests.
-target_link_libraries(_CuraEngine clipper)
+
+if(USE_SYSTEM_LIBS)
+    target_link_libraries(_CuraEngine ${Polyclipping_LIBRARIES})
+else()
+    target_link_libraries(_CuraEngine clipper)
+endif()
+
 if (ENABLE_ARCUS)
     target_link_libraries(_CuraEngine Arcus)
 endif ()
 
 set_target_properties(_CuraEngine PROPERTIES COMPILE_DEFINITIONS "VERSION=\"${CURA_ENGINE_VERSION}\"")
 
+if(WIN32)
+  message(STATUS "Using windres")
+  set(RES_FILES "CuraEngine.rc")
+  set(CMAKE_RC_COMPILER_INIT windres)
+  ENABLE_LANGUAGE(RC)
+  SET(CMAKE_RC_COMPILE_OBJECT
+      "<CMAKE_RC_COMPILER> <FLAGS> -O coff <DEFINES> -i <SOURCE> -o <OBJECT>"
+      )
+endif(WIN32)
+
 if (UNIX)
     target_link_libraries(_CuraEngine pthread)
 endif()
-add_executable(CuraEngine src/main.cpp) #Then compile main.cpp as separate executable, and link the library to it.
+
+if (NOT WIN32)
+  add_executable(CuraEngine src/main.cpp) # Then compile main.cpp as separate executable, and link the library to it.
+else()
+  add_executable(CuraEngine src/main.cpp ${RES_FILES}) # ..., but don't forget the glitter!
+endif(NOT WIN32)
+
 target_link_libraries(CuraEngine _CuraEngine)
+set_target_properties(CuraEngine PROPERTIES COMPILE_DEFINITIONS "VERSION=\"${CURA_ENGINE_VERSION}\"")
 
 # Compiling the test environment.
 if (BUILD_TESTS)

=== debian/changelog ===
cura-engine (1:3.3.0-2) unstable; urgency=medium

  * Updated test case printer definitions

 -- Gregor Riepl <onitake@gmail.com>  Mon, 09 Jul 2018 22:48:42 +0200

cura-engine (1:3.3.0-1) unstable; urgency=medium

  * New upstream release 3.3.0
  * Migrated to salsa
  * Removed obsolete CMakeLists.txt patches, issues were fixed upstream
  * Fixed fortify/debug build flags

 -- Gregor Riepl <onitake@gmail.com>  Mon, 18 Jun 2018 19:06:11 +0200

cura-engine (1:3.2.1-1) unstable; urgency=medium

  * New upstream release 3.2.1

 -- Gregor Riepl <onitake@gmail.com>  Fri, 16 Mar 2018 08:58:08 +0100

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DCURA_ENGINE_VERSION:STRING=$(DEB_VERSION_UPSTREAM) -DBUILD_TESTS=ON -DUSE_SYSTEM_LIBS=ON -DCMAKE_CXX_FLAGS_RELEASE_INIT="$(CXXFLAGS) $(CPPFLAGS)"

## cura-engine 4.4.1

=== CMakeLists.txt ===
#Copyright (c) 2019 Ultimaker B.V.
#CuraEngine is released under the terms of the AGPLv3 or higher.

project(CuraEngine)

cmake_minimum_required(VERSION 3.6.0)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

option(ENABLE_ARCUS "Enable support for ARCUS" ON)

if (MSVC)
    option(MSVC_STATIC_RUNTIME "Link the MSVC runtime statically" OFF)
endif()

if(ENABLE_ARCUS)
    message(STATUS "Building with Arcus")
    # We want to have access to protobuf_generate_cpp and other FindProtobuf features.
    # However, if ProtobufConfig is used instead, there is a CMake option that controls
    # this, which defaults to OFF. We need to force this option to ON instead.
    set(protobuf_MODULE_COMPATIBLE ON CACHE "" INTERNAL FORCE)
    find_package(Protobuf 3.0.0 REQUIRED)
    find_package(Arcus REQUIRED)
    add_definitions(-DARCUS)
endif()

#For reading image files.
find_package(Stb REQUIRED)
include_directories(${Stb_INCLUDE_DIRS})

option(USE_SYSTEM_LIBS "Use the system libraries if available" OFF)
if(USE_SYSTEM_LIBS)
    find_package(RapidJSON CONFIG REQUIRED)
    find_package(Polyclipping REQUIRED)
endif()

# convert build type to upper case letters
if(CMAKE_BUILD_TYPE)
    string(TOUPPER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE_UPPER)
endif()

if(CMAKE_BUILD_TYPE_UPPER MATCHES "DEBUG")
    set(CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS_DEBUG_INIT})
else()
    set(CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS_RELEASE_INIT})
endif()

set(CMAKE_CXX_STANDARD 11)

if(APPLE AND CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
endif()

if(NOT DEFINED LIB_SUFFIX)
    set(LIB_SUFFIX "")
endif()
set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}")

set(CURA_ENGINE_VERSION "master" CACHE STRING "Version name of Cura")

option(BUILD_TESTS OFF)

# Add a compiler flag to check the output for insane values if we are in debug mode.
if(CMAKE_BUILD_TYPE_UPPER MATCHES "DEBUG" OR CMAKE_BUILD_TYPE_UPPER MATCHES "RELWITHDEBINFO")
    message(STATUS "Building debug release of CuraEngine.")
    if (NOT MSVC)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wextra -O0 -g -fno-omit-frame-pointer")
    endif()
    add_definitions(-DASSERT_INSANE_OUTPUT)
    add_definitions(-DUSE_CPU_TIME)
    add_definitions(-DDEBUG)
endif()

if (MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /permissive- /Zc:twoPhase- /EHsc /W3")
    if (MSVC_STATIC_RUNTIME)
        foreach(flag_var
            CMAKE_CXX_FLAGS
            CMAKE_CXX_FLAGS_DEBUG
            CMAKE_CXX_FLAGS_RELEASE
            CMAKE_CXX_FLAGS_MINSIZEREL
            CMAKE_CXX_FLAGS_RELWITHDEBINFO
            )
            if(${flag_var} MATCHES "/MD")
                string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
            endif()
        endforeach()
    endif()
else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall") # Add warnings
endif()

option (ENABLE_MORE_COMPILER_OPTIMIZATION_FLAGS
    "Enable more optimization flags" ON)
if (ENABLE_MORE_COMPILER_OPTIMIZATION_FLAGS AND NOT (CMAKE_BUILD_TYPE_UPPER MATCHES "DEBUG"))
    message (STATUS "Compile with more optimization flags")
    if (MSVC)
        set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS} /fp:fast")
    else()
        set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS} -Ofast -funroll-loops")
    endif()
endif ()

if(NOT APPLE AND NOT WIN32)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -static-libstdc++")
endif()

if (WIN32)
    add_definitions(-DNOMINMAX)
endif()

option (ENABLE_OPENMP
    "Use OpenMP for parallel code" ON)

if (ENABLE_OPENMP)
    FIND_PACKAGE( OpenMP )
    if( OPENMP_FOUND )
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}" )
    endif()
endif()

if(USE_SYSTEM_LIBS)
    include_directories(${Polyclipping_INCLUDE_DIRS} ${CMAKE_BINARY_DIR} ${RAPIDJSON_INCLUDE_DIRS})
else()
    include_directories(${CMAKE_CURRENT_BINARY_DIR} libs libs/clipper)
    add_library(clipper STATIC libs/clipper/clipper.cpp)
endif()

set(engine_SRCS # Except main.cpp.
    src/Application.cpp
    src/bridge.cpp
    src/ConicalOverhang.cpp
    src/ExtruderTrain.cpp
    src/FffGcodeWriter.cpp
    src/FffPolygonGenerator.cpp
    src/FffProcessor.cpp
    src/gcodeExport.cpp
    src/GCodePathConfig.cpp
    src/infill.cpp
    src/InsetOrderOptimizer.cpp
    src/layerPart.cpp
    src/LayerPlan.cpp
    src/LayerPlanBuffer.cpp
    src/MergeInfillLines.cpp
    src/mesh.cpp
    src/MeshGroup.cpp
    src/Mold.cpp
    src/multiVolumes.cpp
    src/pathOrderOptimizer.cpp
    src/Preheat.cpp
    src/PrimeTower.cpp
    src/raft.cpp
    src/Scene.cpp
    src/skin.cpp
    src/SkirtBrim.cpp
    src/SupportInfillPart.cpp
    src/Slice.cpp
    src/sliceDataStorage.cpp
    src/slicer.cpp
    src/support.cpp
    src/timeEstimate.cpp
    src/TopSurface.cpp
    src/TreeSupport.cpp
    src/WallsComputation.cpp
    src/wallOverlap.cpp
    src/Weaver.cpp
    src/Wireframe2gcode.cpp

    src/communication/ArcusCommunication.cpp
    src/communication/ArcusCommunicationPrivate.cpp
    src/communication/CommandLine.cpp
    src/communication/Listener.cpp

    src/infill/ImageBasedDensityProvider.cpp
    src/infill/NoZigZagConnectorProcessor.cpp
    src/infill/ZigzagConnectorProcessor.cpp
    src/infill/SierpinskiFill.cpp
    src/infill/SierpinskiFillProvider.cpp
    src/infill/SpaghettiInfill.cpp
    src/infill/SpaghettiInfillPathGenerator.cpp
    src/infill/SubDivCube.cpp
    src/infill/GyroidInfill.cpp

    src/pathPlanning/Comb.cpp
    src/pathPlanning/GCodePath.cpp
    src/pathPlanning/LinePolygonsCrossings.cpp
    src/pathPlanning/NozzleTempInsert.cpp
    src/pathPlanning/TimeMaterialEstimates.cpp

    src/progress/Progress.cpp
    src/progress/ProgressStageEstimator.cpp

    src/settings/AdaptiveLayerHeights.cpp
    src/settings/FlowTempGraph.cpp
    src/settings/PathConfigStorage.cpp
    src/settings/Settings.cpp

    src/utils/AABB.cpp
    src/utils/AABB3D.cpp
    src/utils/Date.cpp
    src/utils/gettime.cpp
    src/utils/getpath.cpp
    src/utils/LinearAlg2D.cpp
    src/utils/ListPolyIt.cpp
    src/utils/logoutput.cpp
    src/utils/MinimumSpanningTree.cpp
    src/utils/Point3.cpp
    src/utils/PolygonConnector.cpp
    src/utils/PolygonsPointIndex.cpp
    src/utils/PolygonProximityLinker.cpp
    src/utils/polygonUtils.cpp
    src/utils/polygon.cpp
    src/utils/ProximityPointLink.cpp
    src/utils/SVG.cpp
    src/utils/socket.cpp
)

# List of tests. For each test there must be a file tests/${NAME}.cpp.
set(engine_TEST
    GCodeExportTest
    InfillTest
    MergeInfillLinesTest
    TimeEstimateCalculatorTest
)
set(engine_TEST_INFILL
)
set(engine_TEST_INTEGRATION
    SlicePhaseTest
)
set(engine_TEST_SETTINGS
    SettingsTest
)
if (ENABLE_ARCUS)
    set(engine_TEST_ARCUS
        ArcusCommunicationTest
        ArcusCommunicationPrivateTest
    )
endif ()
set(engine_TEST_UTILS
    AABBTest
    AABB3DTest
    IntPointTest
    LinearAlg2DTest
    MinimumSpanningTreeTest
    PolygonConnectorTest
    PolygonTest
    PolygonUtilsTest
    SparseGridTest
    StringTest
    UnionFindTest
)

# Helper classes for some tests.
set(engine_TEST_ARCUS_HELPERS
    tests/arcus/MockSocket.cpp
)
set(engine_TEST_HELPERS
    tests/ReadTestPolygons.cpp
)

# Generating ProtoBuf protocol
if (ENABLE_ARCUS)
    protobuf_generate_cpp(engine_PB_SRCS engine_PB_HEADERS Cura.proto)
endif ()

# Compiling CuraEngine itself.
add_library(_CuraEngine STATIC ${engine_SRCS} ${engine_PB_SRCS}) #First compile all of CuraEngine as library, allowing this to be re-used for tests.

if (CuraEngine_Download_Stb)
    add_dependencies(_CuraEngine stb)
endif()
if(USE_SYSTEM_LIBS)
    target_link_libraries(_CuraEngine ${Polyclipping_LIBRARIES})
else()
    target_link_libraries(_CuraEngine clipper)
endif()

if (ENABLE_ARCUS)
    target_link_libraries(_CuraEngine Arcus)
endif ()

set_target_properties(_CuraEngine PROPERTIES COMPILE_DEFINITIONS "VERSION=\"${CURA_ENGINE_VERSION}\"")

if(WIN32)
  message(STATUS "Using windres")
  set(RES_FILES "CuraEngine.rc")
  ENABLE_LANGUAGE(RC)
  if(NOT MSVC)
    SET(CMAKE_RC_COMPILER_INIT windres)
    SET(CMAKE_RC_COMPILE_OBJECT
        "<CMAKE_RC_COMPILER> <FLAGS> -O coff <DEFINES> -i <SOURCE> -o <OBJECT>"
        )
 endif()
endif(WIN32)

if (UNIX)
    target_link_libraries(_CuraEngine pthread)
endif()

if (NOT WIN32)
  add_executable(CuraEngine src/main.cpp) # Then compile main.cpp as separate executable, and link the library to it.
else()
  add_executable(CuraEngine src/main.cpp ${RES_FILES}) # ..., but don't forget the glitter!
endif(NOT WIN32)

target_link_libraries(CuraEngine _CuraEngine)
set_target_properties(CuraEngine PROPERTIES COMPILE_DEFINITIONS "VERSION=\"${CURA_ENGINE_VERSION}\"")

# Compiling the test environment.
if (BUILD_TESTS)
    include(CTest)

    message(STATUS "Building tests...")
    set(GTEST_USE_STATIC_LIBS true)
    set(GMOCK_ROOT "${CMAKE_CURRENT_BINARY_DIR}/gmock")
    set(GMOCK_VER "1.8.0")
    find_package(GMock REQUIRED)
    include_directories(${GTEST_INCLUDE_DIRS})
    include_directories(${GMOCK_INCLUDE_DIRS})
    add_dependencies(_CuraEngine GTest::GTest GTest::Main GMock::GMock GMock::Main)
    add_definitions(-DBUILD_TESTS)

    target_compile_definitions(_CuraEngine PUBLIC BUILD_TESTS=1)

    #To make sure that the tests are built before running them, add the building of these tests as an additional test.
    add_custom_target(build_all_tests)
    add_test(BuildTests "${CMAKE_COMMAND}" --build ${CMAKE_CURRENT_BINARY_DIR} --target build_all_tests)

    foreach (test ${engine_TEST})
        add_executable(${test} tests/main.cpp ${engine_TEST_HELPERS} tests/${test}.cpp)
        target_link_libraries(${test} _CuraEngine ${GTEST_BOTH_LIBRARIES} ${GMOCK_BOTH_LIBRARIES})
        add_test(NAME ${test} COMMAND "${test}" WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/tests/)
        add_dependencies(build_all_tests ${test}) #Make sure that this gets built as part of the build_all_tests target.
    endforeach()
    foreach (test ${engine_TEST_INFILL})
        add_executable(${test} tests/main.cpp tests/infill/${test}.cpp)
        target_link_libraries(${test} _CuraEngine ${GTEST_BOTH_LIBRARIES} ${GMOCK_BOTH_LIBRARIES})
        add_test(NAME ${test} COMMAND "${test}" WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/tests/)
        add_dependencies(build_all_tests ${test}) #Make sure that this gets built as part of the build_all_tests target.
    endforeach()
    foreach (test ${engine_TEST_INTEGRATION})
        add_executable(${test} tests/main.cpp tests/integration/${test}.cpp)
        target_link_libraries(${test} _CuraEngine ${GTEST_BOTH_LIBRARIES} ${GMOCK_BOTH_LIBRARIES})
        add_test(NAME ${test} COMMAND "${test}" WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/tests/)
        add_dependencies(build_all_tests ${test}) #Make sure that this gets built as part of the build_all_tests target.
    endforeach()
    foreach (test ${engine_TEST_SETTINGS})
        add_executable(${test} tests/main.cpp tests/settings/${test}.cpp)
        target_link_libraries(${test} _CuraEngine ${GTEST_BOTH_LIBRARIES} ${GMOCK_BOTH_LIBRARIES})
        add_test(NAME ${test} COMMAND "${test}" WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/tests/)
        add_dependencies(build_all_tests ${test}) #Make sure that this gets built as part of the build_all_tests target.
    endforeach()
    if (ENABLE_ARCUS)
        foreach (test ${engine_TEST_ARCUS})
            add_executable(${test} tests/main.cpp ${engine_TEST_ARCUS_HELPERS} tests/arcus/${test}.cpp)
            target_link_libraries(${test} _CuraEngine ${GTEST_BOTH_LIBRARIES} ${GMOCK_BOTH_LIBRARIES})
            add_test(NAME ${test} COMMAND "${test}" WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/tests/)
            add_dependencies(build_all_tests ${test}) #Make sure that this gets built as part of the build_all_tests target.
        endforeach()
    endif ()
    foreach (test ${engine_TEST_UTILS})
        add_executable(${test} tests/main.cpp tests/utils/${test}.cpp)

=== debian/changelog ===
cura-engine (1:4.4.1-2) unstable; urgency=medium

  * Team upload.

  [ Gregor Riepl ]
  * Fix data type mismatches on non-x86 architectures (upstream patch)

 -- Christoph Berg <myon@debian.org>  Sun, 09 Feb 2020 21:43:28 +0100

cura-engine (1:4.4.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version.
  * Bump libarcus dependency to 4.4.
  * Add libstb and libgmock dependencies.
  * Fix test that expected the package version to be "master".

 -- Christoph Berg <myon@debian.org>  Tue, 28 Jan 2020 22:09:46 +0100

cura-engine (1:3.3.0-3) unstable; urgency=medium

  * Added patch to fix building with GCC 9. Closes: #925664

 -- Gregor Riepl <onitake@gmail.com>  Fri, 16 Aug 2019 09:09:31 +0200

cura-engine (1:3.3.0-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add upstream FTBFS fix, thanks to Juhani Numminen.
    (Closes: #907157)

 -- Adrian Bunk <bunk@debian.org>  Thu, 27 Sep 2018 20:26:09 +0300

=== debian/control ===
--- 
+++ 
@@ -7,12 +7,14 @@
  libcppunit-dev,
  protobuf-compiler (>=3.0.0), libprotobuf-dev,
  rapidjson-dev, libpolyclipping-dev,
- libarcus-dev (>=3.1.0)
-Standards-Version: 4.1.3
+ libarcus-dev (>= 4.4.0),
+ libgmock-dev,
+ libstb-dev,
+Standards-Version: 4.1.4
 Section: utils
 Homepage: https://github.com/Ultimaker/CuraEngine
-Vcs-Browser: https://anonscm.debian.org/cgit/3dprinter/packages/cura-engine.git/
-Vcs-Git: https://anonscm.debian.org/git/3dprinter/packages/cura-engine.git
+Vcs-Browser: https://salsa.debian.org/3dprinting-team/cura-engine
+Vcs-Git: https://salsa.debian.org/3dprinting-team/cura-engine.git
 
 Package: cura-engine
 Architecture: any

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/(\d\S+)\.tar\.gz/CuraEngine-$1\.tar\.gz/ \
  https://github.com/Ultimaker/CuraEngine/tags .*/(\d\.\S+)\.tar\.gz

## cura-engine 4.5.0

=== debian/changelog ===
cura-engine (1:4.5.0-2build1) groovy; urgency=medium

  * Rebuild against new libprotobuf23.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 26 Jul 2020 10:24:20 +0200

cura-engine (1:4.5.0-2) unstable; urgency=medium

  * Team upload.
  * Allow some precision deviation in tests on i386.
  * Ignore GCodeExportTest failures on mips64el hppa hurd-i386 ia64.

 -- Christoph Berg <myon@debian.org>  Sun, 15 Mar 2020 12:13:32 +0100

cura-engine (1:4.5.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version.

 -- Christoph Berg <myon@debian.org>  Fri, 13 Mar 2020 22:17:52 +0100

=== debian/rules ===
--- 
+++ 
@@ -4,9 +4,18 @@
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
 include /usr/share/dpkg/pkg-info.mk
+export DEB_VERSION_UPSTREAM
+include /usr/share/dpkg/architecture.mk
 
 %:
 	dh $@ --buildsystem=cmake
 
 override_dh_auto_configure:
 	dh_auto_configure -- -DCURA_ENGINE_VERSION:STRING=$(DEB_VERSION_UPSTREAM) -DBUILD_TESTS=ON -DUSE_SYSTEM_LIBS=ON -DCMAKE_CXX_FLAGS_RELEASE_INIT="$(CXXFLAGS) $(CPPFLAGS)"
+
+# GCodeExportTest is failing on some architectures, ignore for now
+# https://github.com/Ultimaker/CuraEngine/issues/1194
+ifneq ($(filter mips64el hppa hurd-i386 ia64,$(DEB_HOST_ARCH)),)
+override_dh_auto_test:
+	-dh_auto_test
+endif

## cura-engine 4.6.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,9 @@
 #Copyright (c) 2019 Ultimaker B.V.
 #CuraEngine is released under the terms of the AGPLv3 or higher.
 
+cmake_minimum_required(VERSION 3.6.0)
+
 project(CuraEngine)
-
-cmake_minimum_required(VERSION 3.6.0)
 
 list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
 
@@ -40,9 +40,9 @@
 endif()
 
 if(CMAKE_BUILD_TYPE_UPPER MATCHES "DEBUG")
-    set(CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS_DEBUG_INIT})
-else()
-    set(CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS_RELEASE_INIT})
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_DEBUG_INIT}")
+else()
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_RELEASE_INIT}")
 endif()
 
 set(CMAKE_CXX_STANDARD 11)
@@ -219,6 +219,7 @@
 set(engine_TEST
     GCodeExportTest
     InfillTest
+    LayerPlanTest
     MergeInfillLinesTest
     TimeEstimateCalculatorTest
 )
@@ -359,4 +360,3 @@
         endforeach()
     endif ()
     foreach (test ${engine_TEST_UTILS})
-        add_executable(${test} tests/main.cpp tests/utils/${test}.cpp)

=== debian/changelog ===
cura-engine (1:4.6.2-1) unstable; urgency=medium

  * Team upload.

  [ Debian Janitor ]
  * Use secure copyright file specification URI.
  * Wrap long lines in changelog entries: 1:2.5.0-3.
  * Bump debhelper from old 10 to 12.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ Christoph Berg ]
  * New upstream version.
  * Cherry-pick patch from upstream to fix mips64el build.

 -- Christoph Berg <myon@debian.org>  Wed, 19 Aug 2020 11:53:16 +0200

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,10 @@
 Priority: optional
 Maintainer: Debian 3-D Printing Packages <3dprinter-general@lists.alioth.debian.org>
 Uploaders: Gregor Riepl <onitake@gmail.com>
-Build-Depends: debhelper (>= 10), cmake (>=2.8.12),
- pkg-config (>=0.29),
+Build-Depends: debhelper-compat (= 12), cmake (>= 2.8.12),
+ pkg-config (>= 0.29),
  libcppunit-dev,
- protobuf-compiler (>=3.0.0), libprotobuf-dev,
+ protobuf-compiler (>= 3.0.0), libprotobuf-dev,
  rapidjson-dev, libpolyclipping-dev,
  libarcus-dev (>= 4.4.0),
  libgmock-dev,

## cura-engine 4.7.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -18,7 +18,7 @@
     # We want to have access to protobuf_generate_cpp and other FindProtobuf features.
     # However, if ProtobufConfig is used instead, there is a CMake option that controls
     # this, which defaults to OFF. We need to force this option to ON instead.
-    set(protobuf_MODULE_COMPATIBLE ON CACHE "" INTERNAL FORCE)
+    set(protobuf_MODULE_COMPATIBLE ON CACHE INTERNAL "" FORCE)
     find_package(Protobuf 3.0.0 REQUIRED)
     find_package(Arcus REQUIRED)
     add_definitions(-DARCUS)
@@ -176,8 +176,6 @@
     src/infill/ZigzagConnectorProcessor.cpp
     src/infill/SierpinskiFill.cpp
     src/infill/SierpinskiFillProvider.cpp
-    src/infill/SpaghettiInfill.cpp
-    src/infill/SpaghettiInfillPathGenerator.cpp
     src/infill/SubDivCube.cpp
     src/infill/GyroidInfill.cpp
 
@@ -360,3 +358,4 @@
         endforeach()
     endif ()
     foreach (test ${engine_TEST_UTILS})
+        add_executable(${test} tests/main.cpp tests/utils/${test}.cpp)

=== debian/changelog ===
cura-engine (1:4.7.1-2) unstable; urgency=medium

  [ Gregor Riepl ]
  * Added build fix for missing algorithm include. Closes: #972808

  [ Christoph Berg ]
  * Add myself to Uploaders.

 -- Christoph Berg <myon@debian.org>  Sun, 01 Nov 2020 22:06:52 +0100

cura-engine (1:4.7.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 4.7.1.

 -- Christoph Berg <myon@debian.org>  Mon, 07 Sep 2020 10:36:14 +0200

## cura-engine 4.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,11 @@
-#Copyright (c) 2019 Ultimaker B.V.
+#Copyright (c) 2020 Ultimaker B.V.
 #CuraEngine is released under the terms of the AGPLv3 or higher.
 
 cmake_minimum_required(VERSION 3.6.0)
 
 project(CuraEngine)
 
-list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
+list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 
 option(ENABLE_ARCUS "Enable support for ARCUS" ON)
 
@@ -120,9 +120,9 @@
 endif()
 
 if(USE_SYSTEM_LIBS)
-    include_directories(${Polyclipping_INCLUDE_DIRS} ${CMAKE_BINARY_DIR} ${RAPIDJSON_INCLUDE_DIRS})
-else()
-    include_directories(${CMAKE_CURRENT_BINARY_DIR} libs libs/clipper)
+    include_directories(${Polyclipping_INCLUDE_DIRS} "${CMAKE_BINARY_DIR}" ${RAPIDJSON_INCLUDE_DIRS})
+else()
+    include_directories("${CMAKE_CURRENT_BINARY_DIR}" libs libs/clipper)
     add_library(clipper STATIC libs/clipper/clipper.cpp)
 endif()
 
@@ -196,6 +196,7 @@
     src/utils/AABB.cpp
     src/utils/AABB3D.cpp
     src/utils/Date.cpp
+    src/utils/FMatrix4x3.cpp
     src/utils/gettime.cpp
     src/utils/getpath.cpp
     src/utils/LinearAlg2D.cpp
@@ -323,37 +324,37 @@
 
     #To make sure that the tests are built before running them, add the building of these tests as an additional test.
     add_custom_target(build_all_tests)
-    add_test(BuildTests "${CMAKE_COMMAND}" --build ${CMAKE_CURRENT_BINARY_DIR} --target build_all_tests)
+    add_test(BuildTests "${CMAKE_COMMAND}" --build "${CMAKE_CURRENT_BINARY_DIR}" --target build_all_tests)
 
     foreach (test ${engine_TEST})
         add_executable(${test} tests/main.cpp ${engine_TEST_HELPERS} tests/${test}.cpp)
         target_link_libraries(${test} _CuraEngine ${GTEST_BOTH_LIBRARIES} ${GMOCK_BOTH_LIBRARIES})
-        add_test(NAME ${test} COMMAND "${test}" WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/tests/)
+        add_test(NAME ${test} COMMAND "${test}" WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/tests/")
         add_dependencies(build_all_tests ${test}) #Make sure that this gets built as part of the build_all_tests target.
     endforeach()
     foreach (test ${engine_TEST_INFILL})
         add_executable(${test} tests/main.cpp tests/infill/${test}.cpp)
         target_link_libraries(${test} _CuraEngine ${GTEST_BOTH_LIBRARIES} ${GMOCK_BOTH_LIBRARIES})
-        add_test(NAME ${test} COMMAND "${test}" WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/tests/)
+        add_test(NAME ${test} COMMAND "${test}" WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/tests/")
         add_dependencies(build_all_tests ${test}) #Make sure that this gets built as part of the build_all_tests target.
     endforeach()
     foreach (test ${engine_TEST_INTEGRATION})
         add_executable(${test} tests/main.cpp tests/integration/${test}.cpp)
         target_link_libraries(${test} _CuraEngine ${GTEST_BOTH_LIBRARIES} ${GMOCK_BOTH_LIBRARIES})
-        add_test(NAME ${test} COMMAND "${test}" WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/tests/)
+        add_test(NAME ${test} COMMAND "${test}" WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/tests/")
         add_dependencies(build_all_tests ${test}) #Make sure that this gets built as part of the build_all_tests target.
     endforeach()
     foreach (test ${engine_TEST_SETTINGS})
         add_executable(${test} tests/main.cpp tests/settings/${test}.cpp)
         target_link_libraries(${test} _CuraEngine ${GTEST_BOTH_LIBRARIES} ${GMOCK_BOTH_LIBRARIES})
-        add_test(NAME ${test} COMMAND "${test}" WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/tests/)
+        add_test(NAME ${test} COMMAND "${test}" WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/tests/")
         add_dependencies(build_all_tests ${test}) #Make sure that this gets built as part of the build_all_tests target.
     endforeach()
     if (ENABLE_ARCUS)
         foreach (test ${engine_TEST_ARCUS})
             add_executable(${test} tests/main.cpp ${engine_TEST_ARCUS_HELPERS} tests/arcus/${test}.cpp)
             target_link_libraries(${test} _CuraEngine ${GTEST_BOTH_LIBRARIES} ${GMOCK_BOTH_LIBRARIES})
-            add_test(NAME ${test} COMMAND "${test}" WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/tests/)
+            add_test(NAME ${test} COMMAND "${test}" WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/tests/")
             add_dependencies(build_all_tests ${test}) #Make sure that this gets built as part of the build_all_tests target.
         endforeach()
     endif ()

=== debian/changelog ===
cura-engine (1:4.8-1) unstable; urgency=medium

  * New upstream version 4.8.
  * debian/watch: Handle -beta releases.

 -- Christoph Berg <myon@debian.org>  Wed, 18 Nov 2020 09:13:54 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: cura-engine
 Priority: optional
 Maintainer: Debian 3-D Printing Packages <3dprinter-general@lists.alioth.debian.org>
-Uploaders: Gregor Riepl <onitake@gmail.com>
+Uploaders: Gregor Riepl <onitake@gmail.com>,
+ Christoph Berg <myon@debian.org>,
 Build-Depends: debhelper-compat (= 12), cmake (>= 2.8.12),
  pkg-config (>= 0.29),
  libcppunit-dev,

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk
export DEB_VERSION_UPSTREAM

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DCURA_ENGINE_VERSION:STRING=$(DEB_VERSION_UPSTREAM) -DBUILD_TESTS=ON -DUSE_SYSTEM_LIBS=ON -DCMAKE_CXX_FLAGS_RELEASE_INIT="$(CXXFLAGS) $(CPPFLAGS)"
